**THIS CODE WAS WRITTEN FOR CBE 782 J.REED (3/2011)
$onecho > cplex.opt
eprhs 0
epopt 0
epint 0
$offecho

*Read in the appropriate S matrix
$include EcoliCoreTextbookModel.gms

*Place limits on the exchange fluxes based on the minimal media for a negative flux through the exchange reactions implies that
*the metabolites are being taken up or consumed by the cell. By default the upperlimits of the exchange fluxes are all set to
*the Vmax, indicating that the cell can secrete any of the extracellular metabolites.

UpperLimits(j)=Vmax;
LowerLimits(exch)=0;

*CARBON SOURCE: select upper and lower limits for exchange flux
LowerLimits('EX_glc_e')=-5;
UpperLimits('EX_glc_e')=-5;

*allow co2,pi,o2,h,h2o to be taken up by the cell
LowerLimits('EX_co2_e')=-Vmax;
LowerLimits('EX_h2o_e')=-Vmax;
LowerLimits('EX_h_e')=-Vmax;
LowerLimits('EX_o2_e')=-Vmax;
LowerLimits('EX_pi_e')=-Vmax;

Parameter
c(j) used to define the objective function for FBA /Biomass 1/;

Variables
v(j) flux values through reaction in network
Obj  this is the value of the objective function for the FBA solutions;

Equations
massbalance(i) mass balance equations for each metabolite
calcobj calculates the dot product of the c vector the flux vector;
massbalance(i).. sum( j,S(i,j)*v(j) )=e=0;
calcobj.. Obj=e=sum( j,c(j)*v(j) );

Model FBA /massbalance, calcobj/;
FBA.optfile=1;

v.lo(j)=LowerLimits(j);
v.up(j)=UpperLimits(j);

solve FBA using lp maximizing Obj;

*This section writes out the results to a txt file
file result /FBA_results.txt/;
result.pw=500; result.pc=5; result.ps=130;
put result;
put "Model status:  "; put FBA.modelstat; put /;
put "Solver status:  "; put FBA.solvestat; put /;
loop(j,put j.tl; put v.l(j):8:4; put /);
putclose result;

*This will write the non-zero values for v and Obj in the LST file
display v.l,Obj.l,massbalance.m;