*THIS CODE WAS WRITTEN FOR CBE782 BY J. REED (4/2011)
$offlisting
$offdigit

$onecho > cplex.opt
eprhs 1e-9
epopt 1e-9
epint 1e-9
$offecho

$include EcoliMatrices.gms

UpperLimits(j)=Vmax;

* Oxygen uptake rate
LowerLimits('EX_o2_e')=-Vmax;
* CO2 uptake
*LowerLimits('EX_co2_e')=-Vmax;
* H2O uptake
LowerLimits('EX_h2o_e')=-Vmax;
* H uptake
LowerLimits('EX_h_e')=-Vmax;
* Phosphate uptake
LowerLimits('EX_pi_e')=-Vmax;

* Carbon source uptake


Variables
v(j) flux values through reaction in existing network
y(k) flux values through reaction in the database
z(i) flux values through transport reactions
Obj  number of needed reactions;

Binary Variable
a(k) binary variables
b(i) binary variables;

Parameters
z_max(i) universal transport reaction maximum fluxes
z_min(i) universal transport reaction maximum fluxes;

z_max(i)=Vmax;
z_min(i)=0;
y_max(k)=Vmax;


* Define Compounds In Media That Aren't In Current Model
z_min('nh4_e')=-Vmax;
z_min('so4_e')=-Vmax;
z_min('xyl-d_e')=-10;

Equations
calcobj minimize the number of added reactions needed
massbalance(i) mass balance equations for each metabolite
ranges_up_y(k)  upper limits on the added fluxes
ranges_low_y(k)  lower limits on the added fluxes
ranges_up_z(i)  upper limits on added transport
ranges_low_z(i) lower limits on added transport
growth set minimum growth rate;

calcobj.. Obj=e=sum( k,a(k))+ sum( i,b(i));
massbalance(i).. sum( j,S(i,j)*v(j) )+ sum( k,U(i,k)*y(k) )  -z(i) =e=0;
ranges_up_y(k).. y(k)=l=( a(k)*y_max(k) );
ranges_low_y(k).. y(k)=g=( a(k)*y_min(k) );
ranges_up_z(i).. z(i)=l=( b(i)*z_max(i) );
ranges_low_z(i).. z(i)=g=( b(i)*z_min(i) );
growth.. v('Biomass')=g=0.05;

model addedrxns /all/;
addedrxns.OptCR=0; addedrxns.OptFile=1;
addedrxns.reslim=100000; option IterLim=50000;

v.lo(j)=LowerLimits(j);
v.up(j)=UpperLimits(j);

solve addedrxns using mip minimizing Obj;

file results /RequiredReactions.txt/;
results.pw=1000; results.pc=5; results.ps=130;
put results;
put "Model status:  "; put addedrxns.modelstat; put /;
put "Solver status:  "; put addedrxns.solvestat; put /;
put 'Number of Added Fluxes';
put Obj.l;
put /; put /;
put "Reactions from Universal Database"; put /;
loop(k,  if(a.l(k)>0, put k.tl;  put y.l(k):8:4;   
   loop(i, if(U(i,k)<0, put U(i,k); put i.tl; ); );
   loop(i, if(U(i,k)>0, put U(i,k); put i.tl; ); );
put /;); );

put /;
put "Transport Reactions (Pos=Secretion, Neg=Uptake)"; put /;
loop(i,  if(b.l(i)>0, put i.tl;  put z.l(i):8:4;   put /;); );
putclose results
